angular.module('mrt', ['ionic','ngRoute'])
// pending truncate table if records not match
.service('persistencejs', function() {
	persistence.store.websql.config(persistence,'mrt', 'mrt database', 5*1024*1024);
	var TrainLine = persistence.define('TrainLine', {
		code: 'TEXT',
		title: 'TEXT',
		color: 'TEXT'
	});
	var EWTrain = persistence.define('EWTrain', {
		code: 'TEXT',
		title: 'TEXT',
		interchange: 'TEXT',
		mall: 'TEXT'
	});
	var NSTrain = persistence.define('NSTrain', {
		code: 'TEXT',
		title: 'TEXT',
		interchange: 'TEXT',
		mall: 'TEXT'
	});
		
	
	this.init = function($scope){
	
	persistence.schemaSync(function(tx) { 
	
	//init train line
	 TrainLine.all().count(null, function(result){
			 
		 var request = new XMLHttpRequest();
			request.open("GET", "data/lines.txt", true);
			request.onreadystatechange = function(){
				if (request.readyState == 4) {
					if (request.status == 200 || request.status == 0) {
						
						
						var resSplit = request.responseText.split( "\n" );
						
						if(result == 0 || result != resSplit.length){
						
						
							for(var i = 0; i < resSplit.length; i++){
								
								var lineSplit = resSplit[i].split("|");
								
								var t = new TrainLine();
								t.code = lineSplit[0];
								t.title = lineSplit[1];
								t.color = lineSplit[2];
								persistence.add(t);
							}
						
							persistence.flush();
						}
						 
						$scope.lines = [];
						TrainLine.all().list(null, function (results) {
							results.forEach(function (r) {
								$scope.$apply(function () {
								$scope.lines.push({code: r.code, title: r.title, color: r.color});
							});
						});
						});
						
					}
				}
			}
			request.send();
				
		
		
		});
		
		//init ew train
		EWTrain.all().count(null, function(result){
			
		
			 
			 var request = new XMLHttpRequest();
				request.open("GET", "data/EW.txt", true);
				request.onreadystatechange = function(){
					if (request.readyState == 4) {
						if (request.status == 200 || request.status == 0) {
							
							
							var resSplit = request.responseText.split( "\n" );
							
							if(result == 0 || result != resSplit.length){
						
								for(var i = 0; i < resSplit.length; i++){
									
									var lineSplit = resSplit[i].split("|");
									
									var t = new EWTrain();
									t.code = lineSplit[0];
									t.title = lineSplit[1];
									t.interchange = lineSplit[2];
									t.mall = lineSplit[3];
									persistence.add(t);
								}
								
								persistence.flush();
							
							}
							
							
							$scope.EW = [];
		
							EWTrain.all().list(null, function (results) {
								results.forEach(function (r) {
								 $scope.$apply(function () {
								 
									var inter = [];
									
									if(r.interchange != ''){
									
										var interSplit = r.interchange.split(";");
										
										if(interSplit.length > 0){
										
											for(var i = 0; i < interSplit.length; i++){
												var color = '';
											
												if(interSplit[i].substring(0,2) == 'EW'){
													color = '#009530';
												}else if(interSplit[i].substring(0,2) == 'NS'){
													color = '#DC241F';
												}else if(interSplit[i].substring(0,2) == 'NE'){
													color = '#9016B2';
												}else if(interSplit[i].substring(0,2) == 'CC'){
													color = '#FF9A00';
												}else if(interSplit[i].substring(0,2) == 'DT'){
													color = '#0354A6';
												}
												inter.push({code: interSplit[i], color: color});
											}
											
										}else{
											
											var color = '';
											
											if(r.interchange.substring(0,2) == 'EW'){
												color = '#009530';
											}else if(r.interchange.substring(0,2) == 'NS'){
												color = '#DC241F';
											}else if(r.interchange.substring(0,2) == 'NE'){
												color = '#9016B2';
											}else if(r.interchange.substring(0,2) == 'CC'){
												color = '#FF9A00';
											}else if(r.interchange.substring(0,2) == 'DT'){
												color = '#0354A6';
											}
											inter.push({code: r.interchange, color: color});
										}
										
									}
									
									$scope.EW.push({code: r.code, title: r.title, interchange: inter,mall: r.mall.trim()});
								});
							});
							});
						}
					}
				}
				request.send();
				
			
		
		});
		//init ns train
		NSTrain.all().count(null, function(result){
			
		
			 
			 var request = new XMLHttpRequest();
				request.open("GET", "data/NS.txt", true);
				request.onreadystatechange = function(){
					if (request.readyState == 4) {
						if (request.status == 200 || request.status == 0) {
							
							var resSplit = request.responseText.split( "\n" );
							console.log(request.responseText);
							if(result == 0 || result != resSplit.length){
						
								for(var i = 0; i < resSplit.length; i++){
									
									var lineSplit = resSplit[i].split("|");
									
									var t = new NSTrain();
									t.code = lineSplit[0];
									t.title = lineSplit[1];
									t.interchange = lineSplit[2];
									t.mall = lineSplit[3];
									
									persistence.add(t);
								}
								
								persistence.flush();
							
							}
							
							
							$scope.NS = [];
		
							NSTrain.all().list(null, function (results) {
								results.forEach(function (r) {
								 $scope.$apply(function () {
								 
									var inter = [];
									
									if(r.interchange != ''){
									
										var interSplit = r.interchange.split(";");
										
										if(interSplit.length > 0){
										
											for(var i = 0; i < interSplit.length; i++){
												var color = '';
											
												if(interSplit[i].substring(0,2) == 'EW'){
													color = '#009530';
												}else if(interSplit[i].substring(0,2) == 'NS'){
													color = '#DC241F';
												}else if(interSplit[i].substring(0,2) == 'NE'){
													color = '#9016B2';
												}else if(interSplit[i].substring(0,2) == 'CC'){
													color = '#FF9A00';
												}else if(interSplit[i].substring(0,2) == 'DT'){
													color = '#0354A6';
												}
												inter.push({code: interSplit[i], color: color});
											}
											
										}else{
											
											var color = '';
											
											if(r.interchange.substring(0,2) == 'EW'){
												color = '#009530';
											}else if(r.interchange.substring(0,2) == 'NS'){
												color = '#DC241F';
											}else if(r.interchange.substring(0,2) == 'NE'){
												color = '#9016B2';
											}else if(r.interchange.substring(0,2) == 'CC'){
												color = '#FF9A00';
											}else if(r.interchange.substring(0,2) == 'DT'){
												color = '#0354A6';
											}
											inter.push({code: r.interchange, color: color});
										}
										
									}
									console.log(r.title+"="+r.mall+"|");
									$scope.NS.push({code: r.code, title: r.title, interchange: inter,mall: r.mall.trim()});
								});
							});
							});
						}
					}
				}
				request.send();
				
			
		
		});
		//
		
	  var line = {code:'EW',title:'East West Line',header:'bar-balanced'};
	  $scope.type = 'mall';
	  $scope.activeLine = line;
	  
	  window.localStorage['loadDatabase'] = true;
	  
	  $scope.hide();
	});
		
	},
	this.selectAllTrainLine = function($scope){
	 var line = {code:'EW',title:'East West Line',header:'bar-balanced'};
	  $scope.type = 'mall';
	  $scope.activeLine = line;
	  
		$scope.lines = [];
		TrainLine.all().list(null, function (results) {
			results.forEach(function (r) {
				$scope.$apply(function () {
				$scope.lines.push({code: r.code, title: r.title, color: r.color});
			});
		});
		});
		
		$scope.EW = [];
		
		EWTrain.all().list(null, function (results) {
			results.forEach(function (r) {
			 $scope.$apply(function () {
			 
				var inter = [];
				
				if(r.interchange != ''){
				
					var interSplit = r.interchange.split(";");
					
					if(interSplit.length > 0){
					
						for(var i = 0; i < interSplit.length; i++){
							var color = '';
						
							if(interSplit[i].substring(0,2) == 'EW'){
								color = '#009530';
							}else if(interSplit[i].substring(0,2) == 'NS'){
								color = '#DC241F';
							}else if(interSplit[i].substring(0,2) == 'NE'){
								color = '#9016B2';
							}else if(interSplit[i].substring(0,2) == 'CC'){
								color = '#FF9A00';
							}else if(interSplit[i].substring(0,2) == 'DT'){
								color = '#0354A6';
							}
							inter.push({code: interSplit[i], color: color});
						}
						
					}else{
						
						var color = '';
						
						if(r.interchange.substring(0,2) == 'EW'){
							color = '#009530';
						}else if(r.interchange.substring(0,2) == 'NS'){
							color = '#DC241F';
						}else if(r.interchange.substring(0,2) == 'NE'){
							color = '#9016B2';
						}else if(r.interchange.substring(0,2) == 'CC'){
							color = '#FF9A00';
						}else if(r.interchange.substring(0,2) == 'DT'){
							color = '#0354A6';
						}
						inter.push({code: r.interchange, color: color});
					}
					
				}
				
				$scope.EW.push({code: r.code, title: r.title, interchange: inter,mall: r.mall.trim()});
			});
		});
		});
		
		$scope.NS = [];

		NSTrain.all().list(null, function (results) {
			results.forEach(function (r) {
			 $scope.$apply(function () {
			 
				var inter = [];
				
				if(r.interchange != ''){
				
					var interSplit = r.interchange.split(";");
					
					if(interSplit.length > 0){
					
						for(var i = 0; i < interSplit.length; i++){
							var color = '';
						
							if(interSplit[i].substring(0,2) == 'EW'){
								color = '#009530';
							}else if(interSplit[i].substring(0,2) == 'NS'){
								color = '#DC241F';
							}else if(interSplit[i].substring(0,2) == 'NE'){
								color = '#9016B2';
							}else if(interSplit[i].substring(0,2) == 'CC'){
								color = '#FF9A00';
							}else if(interSplit[i].substring(0,2) == 'DT'){
								color = '#0354A6';
							}
							inter.push({code: interSplit[i], color: color});
						}
						
					}else{
						
						var color = '';
						
						if(r.interchange.substring(0,2) == 'EW'){
							color = '#009530';
						}else if(r.interchange.substring(0,2) == 'NS'){
							color = '#DC241F';
						}else if(r.interchange.substring(0,2) == 'NE'){
							color = '#9016B2';
						}else if(r.interchange.substring(0,2) == 'CC'){
							color = '#FF9A00';
						}else if(r.interchange.substring(0,2) == 'DT'){
							color = '#0354A6';
						}
						inter.push({code: r.interchange, color: color});
					}
					
				}
				console.log(r.title+"="+r.mall+"|");
				$scope.NS.push({code: r.code, title: r.title, interchange: inter,mall: r.mall.trim()});
			});
		});
		});
		
		$scope.hide();
		
	};
	//singleton containing all methods to be called
	
})

.config(['$routeProvider',  function($routeProvider) {
    $routeProvider.
      when('/EW', {
        templateUrl: 'view/EW.html',
        controller: 'EWController'
    }).when('/NS', {
        templateUrl: 'view/NS.html',
        controller: 'NSController'
    }).
      otherwise({
        redirectTo: '/EW'
      });
}])

.factory('Train', function() {

  return {
   
    getLastActiveIndex: function() {
      return parseInt(window.localStorage['lastActiveProject']) || 0;
    },
    setLastActiveIndex: function(index) {
      window.localStorage['lastActiveProject'] = index;
    }
  }
})

.controller('EWController', function($scope,$ionicLoading) {
     
     $scope.hide();
})

.controller('NSController', function($scope,$ionicLoading) {
     
     $scope.hide();
})

.controller('MrtCtrl', function($scope,persistencejs,$ionicActionSheet,$ionicLoading) {

	$scope.show = function() {

    // Show the loading overlay and text
    $scope.loading = $ionicLoading.show({

      // The text to display in the loading indicator
      content: 'Loading',

      // The animation to use
      animation: 'fade-in',

      // Will a dark overlay or backdrop cover the entire view
      showBackdrop: true,

      // The maximum width of the loading indicator
      // Text will be wrapped if longer than maxWidth
      maxWidth: 200,

      // The delay in showing the indicator
      showDelay: 0
    });
  };

  // Hide the loading indicator
  $scope.hide = function(){
    $scope.loading.hide();
  };
	
  var loaded = window.localStorage['loadDatabase'];
  
      if(loaded) {
		$scope.show();
        persistencejs.selectAllTrainLine($scope);
      }else{
	  
	  $scope.show();
	persistencejs.init($scope);
}
  
 
  
  $scope.toggleMenu = function() {
	$scope.sideMenuController.toggleLeft();
  };

  
  $scope.selectLine = function(line, index) {
  
	if($scope.activeLine.code == line.code){
		$scope.sideMenuController.close();
		return;
	}
	
	if(line.code == 'EW'){
		line.header = 'bar-balanced';
	}else if(line.code == 'NS'){
		line.header = 'bar-assertive';
	}else if(line.code == 'NE'){
		line.header = 'bar-royal';
	}else if(line.code == 'CC'){
		line.header = 'bar-energized';
	}else if(line.code == 'DT'){
		line.header = 'bar-positive';
	}
	
	
	 $scope.activeLine = line;
	$scope.sideMenuController.close();
	$scope.show();
	
	
  };
  
  $scope.actionShow = function() {

    // Show the action sheet
    $ionicActionSheet.show({

      // The various non-destructive button choices
      buttons: [
        { text: 'Shopping Mall' },
        { text: 'Library' },
      ],


      // The title text at the top
      titleText: 'Select type',

      // The text of the cancel button
      cancelText: 'Cancel',

      // Called when the sheet is cancelled, either from triggering the
      // cancel button, or tapping the backdrop, or using escape on the keyboard
      cancel: function() {
      },

      // Called when one of the non-destructive buttons is clicked, with
      // the index of the button that was clicked. Return
      // "true" to tell the action sheet to close. Return false to not close.
      buttonClicked: function(index) {
	  
	    if(index == 0){
			$scope.type = 'mall';
		}else if(index == 1){
			$scope.type = 'library';
		}
		
        return true;
      },

      
    });

  };
});

